const JsBridge = function () {};
const clearWindowsEnv = (callback) => {
    setTimeout(() => {
        delete(window)[callback];
    }, 10);
};
const sendNative = function (name, params, callback) {
    if(typeof params === 'function') {
        callback = params
        params = {}
    }
    const paramsToJson = JSON.stringify({
        name,
        params
    })
    
    if (window.ENV === 'IOS') {
        const pre = "IOS_CALLBACK_"
        window[pre + name] = (data) => {
            callback(data ? data : null)
            clearWindowsEnv(pre + name)
        }
        window.webkit.messageHandlers.IOS.postMessage(
            paramsToJson
        )
    }
    if (window.ENV === 'Android') {
        const data =  window.JsBridgeAndroid.postMessageAndroid(
            paramsToJson
        )
        if (name === 'getCurrentLocation') {
            callback(JSON.parse(data));
        } else {
            callback(data);
        }
    }
}
JsBridge.prototype.call = function (name, params, callback) {
    sendNative(name, params, callback)
}

window.JSBridge = new JsBridge();
